#!/usr/bin/python
#reads in all files with diff extension,creates array with all perturbations length 
import pylab
import numpy
import glob
import numpy.numarray
import re

####### USER SETTINGS #####
# requires a sequence file, one residue number per line
#enter sequence filename and path below
#eg (without #):
#1 M
#20 V

fseq = open("methyl_ass.seq","r")

###########################

files = glob.glob("*.diff")
q = 0
ridx = 0
resfile = []
resind = []
seqarr = []
for xseq in fseq:
   seqarr.append([int(xseq.split()[0]),xseq.split()[1]])
for file in files:
   try:
     ridx += 1
     #residue number from filename
   #  print int(re.match(r'\d+', file.strip()).group())
     resfile.append([int(re.match(r'\d+', file.strip()).group()), ridx-1])
   except:
     print "EXCEPTION: file must begin with residue number"
     print file 
     continue 
resfile.sort(key = lambda x: x[0])
print resfile
lastr = 0
nres2 = len(resfile)
nres = len(seqarr)
mat3 = numpy.numarray.zeros([nres,nres2],numpy.numarray.Float64)
k = 0
for res in resfile:   #load each chem shift file
   ster = 0
   parr = []
   xarr = []
   temp = open(files[res[1]].strip(),"r")
   for line in temp:
      xarr.append(line.split())    #populate xarr with chem shifts and res.
   temp.close()
   xarr.sort(key = lambda x: int(x[0]))
   pasts = 0
   maxtem =  float(max(xarr, key=lambda x: float(x[2]))[2])
   for seqi in seqarr:    #loop over methyl seq
         seqidx = [id for id, y in enumerate(map(lambda x: int(x[0]), xarr)) if y == int(seqi[0])]
         if pasts != int(seqi[0]) and int(seqi[0]) == int(res[0]):
	 #find seq in chem shift list
            parr.append([int(res[0]), maxtem, seqi[1]])  #mutated residue  ## set to max in arr
         elif pasts != int(seqi[0]) and len(seqidx) > 0:
	      avgx= sum(map(lambda x: (float(xarr[int(x)][2]))/len(seqidx), seqidx))
              parr.append([int(seqi[0]), float(avgx), seqi[1]])
         elif pasts == int(seqi[0]) and len(seqidx) < 2:
            parr.append([int(seqi[0]), numpy.NaN, 0])   
         elif pasts != int(seqi[0]):
            parr.append([int(seqi[0]), numpy.NaN, 0])  
         pasts = int(seqi[0])  #set current seq as past
   for m in range(len(parr)):
         try:
           mat3[m][k] = float(parr[m][1])
         except:
           mat3[m][k] = parr[m][1]
   k += 1
fout2 = open("CSP_arr.out","w")
mat3.resize(len(parr),len(resfile))
print len(mat3), len(parr), len(resfile)
print parr
for lo in range(len(parr)):
   if lo == 0:  fout2.write("\"%s%i\""%((parr[lo][2]),int(parr[lo][0])))
   else:   fout2.write(" ,\"%s%i\""%((parr[lo][2]),int(parr[lo][0]))) 
fout2.write("\n")
print len(mat3[1])
for i in range(len(mat3[1,])):
   for j in range(len(mat3)):
       if j==0: fout2.write("%f"%((mat3[j][i])))
       else: fout2.write(" ,%f"%((mat3[j][i])))
   fout2.write("\n")

fout2.close()


 
